#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import sys

sys.path.append("../../lib/")

from leda_python import leda
from leda_python.mbus import MbusBase
from common.log import Log
import hashlib
import logging
import threading
import json
import time


class Demo_device(leda.BaseDeviceCallback):
    def __init__(self):
        self.name = "jys"

    def callService(self, name, input):
        pass

    def getprofile_cb(self):
        pass

    def getProperties(self, input):
        pass

    def setProperties(self, input):
        pass


def createThread(task, *args):
    t = threading.Thread(target=task, args=args)
    t.setDaemon(True)
    t.start()


def test_registerAndonline(driverObj, device_num):
    print('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>')
    driver_name = "abc123"
    driverObj.moduleInit(driver_name)

    product_key = 'abcdefghigk'
    productConfig = {
        "header": {},
        "properties": [],
        "services": [],
        "events": []
    }

    profile_dict = {
        "properties": [],
        "services": [],
        "events": []
    }

    profile = json.dumps(profile_dict)

    class Demo_device(leda.BaseDeviceCallback):
        def __init__(self):
            self.name = "deviceMbus"

        def callService(self, name, input):
            method_name = 'method_1'
            print("method%s, inparam: %s" % (name, input))

            if (name == method_name):
                outPut = {
                    "key1": "xxx",
                    "key2": "yyy",
                    "key3": "zzz",
                }
                return 0, outPut

        def getprofile_cb(self):
            profile_dict = {
                "properties": [],
                "services": [],
                "events": []
            }

            return json.dumps(profile_dict)

        def getProperties(self, input):
            _logger.debug("method: get property inparams:%s" % input)

            input_json = input
            output_json = {}

            for property in input_json:
                output_json[property] = "xxx"

            return output_json

        def setProperties(self, input):
            _logger.debug("method: set property inparams:%s" % input)

            output = {}
            return output

    tmpName = 'deviceaabb'
    deviceObj = []
    time_total = 0
    for i in range(0, device_num):
        device_name = tmpName + str(i)
        bus_callback_object = Demo_device()
        try:
            time_start = time.time()
            TmpdeviceObj = driverObj.deviceRegister(device_name, product_key, profile, bus_callback_object)
            time_end = time.time()
            time_signal = time_end - time_start
            deviceObj.append(TmpdeviceObj)
            assertID = 1
        except:
            assertID = 0
        assert assertID == 1
        time_total = time_total + time_signal
    time_avl = time_total / device_num
    _logger.info("%d device register,total time = %f ,average time = %f", device_num, time_total, time_avl)
    print('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>')

    time_total = 0
    for i in range(0, device_num):
        try:
            time_start = time.time()
            deviceObj[i].online()
            time_end = time.time()
            time_signal = time_end - time_start
            assertID = 1
        except:
            assertID = 0
        assert assertID == 1
        time_total = time_total + time_signal
    time_avl = time_total / device_num
    _logger.info("%d device online,total time = %f ,average time = %f", device_num, time_total, time_avl)
    print('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>')

    time_total = 0
    for i in range(0, device_num):
        try:
            time_start = time.time()
            deviceObj[i].offline()
            time_end = time.time()
            time_signal = time_end - time_start
            assertID = 1
        except:
            assertID = 0
        assert assertID == 1
        time_total = time_total + time_signal
    time_avl = time_total / device_num
    _logger.info("%d device offline,total time = %f ,average time = %f", device_num, time_total, time_avl)
    print('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>')

    time_total = 0
    for i in range(0, device_num):
        try:
            deviceObj[i].online()
            assertID = 1
        except:
            assertID = 0
        assert assertID == 1

    time_total = 0
    properties_dict = {
        "propertyName1": "xxx",
        "propertyName2": "yyy",
        "propertyName3": "zzz"
    }
    for i in range(0, device_num):
        try:
            time_start = time.time()
            deviceObj[i].reportProperties(properties_dict)
            time_end = time.time()
            time_signal = time_end - time_start
            assertID = 1
        except:
            assertID = 0
        assert assertID == 1
        time_total = time_total + time_signal
    time_avl = time_total / device_num
    _logger.info("%d device property,total time = %f ,average time = %f", device_num, time_total, time_avl)
    print('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>')

    time_total = 0
    event_dict = {
        "key1": "value1",
        "key2": "value2"
    }
    for i in range(0, device_num):
        try:
            time_start = time.time()
            deviceObj[i].reportEvent("event", event_dict)
            time_end = time.time()
            time_signal = time_end - time_start
            assertID = 1
        except:
            assertID = 0
        assert assertID == 1
        time_total = time_total + time_signal
    time_avl = time_total / device_num
    _logger.info("%d device event,total time = %f ,average time = %f", device_num, time_total, time_avl)
    print('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>')


def test_getAllDeviceList(mbusObject, device_num):
    print('test_getAllDeviceList')
    interfaceHandle = mbusObject.getRemoteInterface("iot.driver.abc123",
                                                    "/iot/driver/abc123",
                                                    "iot.driver.abc123")
    time_start = time.time()
    retInfo = interfaceHandle.getDeviceList('')
    retInfo = json.loads(retInfo)
    time_end = time.time()
    time_signal = time_end - time_start

    deviceNum = retInfo["params"]["devNum"]
    deviceCloudId_list = retInfo["params"]["devList"]

    _logger.info("get %d device list,total time = %d", device_num, time_signal)
    print('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>')


def test_getProfile(mbusObject, device_num):
    print('test_getProfile')
    time_total = 0
    for i in range(0, device_num):
        wkn = "iot.device.idabcdefghigk_deviceaabb" + str(i)
        objpath = "/iot/device/idabcdefghigk_deviceaabb" + str(i)
        interface = wkn

        interfaceHandle = mbusObject.getRemoteInterface(wkn, objpath, interface)
        time_start = time.time()
        retInfo = interfaceHandle.getDeviceProfile()
        time_end = time.time()
        time_signal = time_end - time_start
        time_total = time_total + time_signal
        retInfo = json.loads(retInfo)
        code = retInfo["code"]
        assert code == 0
    time_avl = time_total / device_num
    _logger.info("%d device get profile,total time = %f ,average time = %f", device_num, time_total, time_avl)
    print('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>')


def test_callMethod(mbusObject, device_num):
    print('test_callMethod')
    time_total = 0
    for i in range(0, device_num):
        inparam = {
            "params": {
                "args1": "xxx",
                "args2": "yyy"
            }
        }
        wkn = "iot.device.idabcdefghigk_deviceaabb" + str(i)
        objpath = "/iot/device/idabcdefghigk_deviceaabb" + str(i)
        interface = wkn
        interfaceHandle = mbusObject.getRemoteInterface(wkn, objpath, interface)
        time_start = time.time()
        retInfo = interfaceHandle.callServices("method_1", json.dumps(inparam))
        time_end = time.time()
        time_signal = time_end - time_start
        time_total = time_total + time_signal
        retInfo = json.loads(retInfo)
        code = retInfo["code"]
        assert code == 0
    time_avl = time_total / device_num
    _logger.info("%d device call method,total time = %f ,average time = %f", device_num, time_total, time_avl)
    print('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>')


def test_call_get(mbusObject, device_num):
    print('test_call_get')
    time_total = 0
    for i in range(0, device_num):
        wkn = "iot.device.idabcdefghigk_deviceaabb" + str(i)
        objpath = "/iot/device/idabcdefghigk_deviceaabb" + str(i)
        interface = wkn

        inparam = {
            "params": ["key1", "key2"]
        }
        interfaceHandle = mbusObject.getRemoteInterface(wkn, objpath, interface)
        time_start = time.time()
        retInfo = interfaceHandle.callServices("get", json.dumps(inparam))
        time_end = time.time()
        time_signal = time_end - time_start
        time_total = time_total + time_signal
        _logger.debug("\tget retInfo: %s  ...Ok", retInfo)
        retInfo = json.loads(retInfo)
        code = retInfo["code"]
        assert code == 0
    time_avl = time_total / device_num
    _logger.info("%d device get,total time = %f ,average time = %f", device_num, time_total, time_avl)
    print('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>')


def test_call_set(mbusObject, device_num):
    print('test_call_set')
    time_total = 0
    for i in range(0, device_num):
        wkn = "iot.device.idabcdefghigk_deviceaabb" + str(i)
        objpath = "/iot/device/idabcdefghigk_deviceaabb" + str(i)
        interface = wkn

        inparam = {
            "params": {
                "key1": "value1",
                "key2": "value2"
            }
        }
        interfaceHandle = mbusObject.getRemoteInterface(wkn, objpath, interface)
        time_start = time.time()
        retInfo = interfaceHandle.callServices("set", json.dumps(inparam))
        time_end = time.time()
        time_signal = time_end - time_start
        time_total = time_total + time_signal
        _logger.debug("\tset retInfo: %s  ...Ok", retInfo)
        retInfo = json.loads(retInfo)
        code = retInfo["code"]
        assert code == 0
    time_avl = time_total / device_num
    _logger.info("%d device set,total time = %f ,average time = %f", device_num, time_total, time_avl)
    print('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>')


if (__name__ == "__main__"):
    device_num = int(sys.argv[1])
    _logger = Log(logging.INFO, "checkin").getLogger()
    _logger.debug("demo driver testing...")
    mbusObject = MbusBase("iot.app.demoTest")
    for i in range(0, 10000):
        driverObj = leda.LedaModule()
        test_registerAndonline(driverObj, device_num)

        test_getAllDeviceList(mbusObject, device_num)
        test_getProfile(mbusObject, device_num)
        test_callMethod(mbusObject, device_num)
        test_call_get(mbusObject, device_num)
        test_call_set(mbusObject, device_num)
        driverObj._releaseMbusObject()

    while (1):
        time.sleep(1)

# instance = Demo_device()
#
# deviceObj1 = driverObj.deviceRegister("device123", "product123", "profile123", instance)
# deviceObj2 = driverObj.deviceRegister("device124", "product124", "profile124", instance)
# deviceObj3 = driverObj.deviceRegister("device125", "product125", "profile125", instance)
# deviceObj4 = driverObj.deviceRegister("device126", "product126", "profile126", instance)
# deviceObj5 = driverObj.deviceRegister("device1214", "product1214", "profile1214", instance)
# deviceObj6 = driverObj.deviceRegister("device127", "product127", "profile127", instance)
#
# deviceObj7 = driverObj.deviceRegister("device128", "product128", "profile128", instance)
# deviceObj8 = driverObj.deviceRegister("device129", "product129", "profile129", instance)
# deviceObj9 = driverObj.deviceRegister("device1210", "product1210", "profile1210", instance)
# deviceObj10 = driverObj.deviceRegister("device1211", "product1211",  "profile1211", instance)
# deviceObj11 = driverObj.deviceRegister("device1212", "product1212", "profile1212", instance)
# deviceObj12 = driverObj.deviceRegister("device1213", "product1213", "profile1213", instance)
#
# while(1):
# 	time.sleep(2)
# 	deviceObj1.offline()
# 	deviceObj2.online()
# 	deviceObj3.online()
# 	deviceObj4.offline()
# 	deviceObj5.offline()
# 	deviceObj6.online()
# 	deviceObj7.online()
# 	deviceObj8.offline()
# 	deviceObj9.online()
# 	deviceObj10.online()
# 	deviceObj11.online()
# 	deviceObj12.offline()
# 	print('')
# 	time.sleep(2)
# 	deviceObj1.online()
# 	deviceObj2.offline()
# 	deviceObj3.offline()
# 	deviceObj4.online()
# 	deviceObj5.online()
# 	deviceObj6.offline()
# 	deviceObj7.offline()
# 	deviceObj8.online()
# 	deviceObj9.offline()
# 	deviceObj10.offline()
# 	deviceObj11.offline()
# 	deviceObj12.online()
# 	print('')
